﻿using System;
using System.Web;
using System.Web.Mvc;

namespace ASPNET_MVC_HelloWorldSVRest.Controllers
{
    public class UploadFileController : Controller
    {
        //
        // GET: /UploadFile/

        public class MyViewModel
        {
            public string Message { get; set; }
        }

        public ActionResult Index()
        {
            MyViewModel model = new MyViewModel
            {
                Message = TempData["message"] as string,
            };
            return View(model);
        }

        [HttpPost]
        public ActionResult Index(int? id)
        {
            Models.SmartVault smartVault = (Models.SmartVault)Session["smartVault"];
            HttpPostedFileBase uploadedFile = Request.Files[0];

            if (uploadedFile != null)
            {
                smartVault.UploadFile(uploadedFile.InputStream, GetRemoteFolder(smartVault), uploadedFile.FileName);
                Session["remoteFile"] = GetRemoteFolder(smartVault) + "/" + uploadedFile.FileName;
                TempData["message"] = "File uploaded successfully.";
                return RedirectToAction("index");
            }

            TempData["message"] = null;
            return RedirectToAction("index");
        }

        public string GetRemoteFolder(Models.SmartVault smartVault)
        {
            var rootNode = smartVault.BrowsePath("/nodes/pth");
            string account = rootNode.Message.ChildrenList[0].Name;

            return String.Format("/nodes/pth/{0}/My First Vault/My First folder", account);
        }

    }
}
